/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.aybkamen.tfc.beans;

import com.aybkamen.tfc.BeanResolver;
import com.aybkamen.tfc.persistencia.ConectorDatos;
import com.aybkamen.tfc.recursos.RecursoTuristico;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.Locale;
import javax.faces.model.SelectItem;


/**
 *
 * @author aybkamen
 */
public class BuscadorRecursosBean {

    private ConectorDatos datos;

    private String textoBusqueda = "";
    private String buscarClase;
    private String buscarLugar;

    private boolean buscarVideo = false;
    private boolean buscarImagen = false;
    private boolean buscarWeb = false;
    private boolean buscarWiki = false;

    /** Creates a new instance of BuscadorRecursos */
    public BuscadorRecursosBean() {
    }

    public ConectorDatos getDatos(){
        if(datos==null){
            datos = BeanResolver.getPersistanceBean().getConector();
        }
        return datos;
    }

    public String getTextoBusqueda() {
        return textoBusqueda;
    }

    public void setTextoBusqueda(String textoBusqueda) {
        this.textoBusqueda = textoBusqueda;
    }

    public String getBuscarClase() {
        return buscarClase;
    }

    public void setBuscarClase(String buscarClase) {
        this.buscarClase = buscarClase;
    }

    public String getBuscarLugar() {
        return buscarLugar;
    }

    public void setBuscarLugar(String buscarLugar) {
        this.buscarLugar = buscarLugar;
    }

    public boolean isBuscarImagen() {
        return buscarImagen;
    }

    public void setBuscarImagen(boolean buscarImagen) {
        this.buscarImagen = buscarImagen;
    }

    public boolean isBuscarVideo() {
        return buscarVideo;
    }

    public void setBuscarVideo(boolean buscarVideo) {
        this.buscarVideo = buscarVideo;
    }

    public boolean isBuscarWeb() {
        return buscarWeb;
    }

    public void setBuscarWeb(boolean buscarWeb) {
        this.buscarWeb = buscarWeb;
    }

    public boolean isBuscarWiki() {
        return buscarWiki;
    }

    public void setBuscarWiki(boolean buscarWiki) {
        this.buscarWiki = buscarWiki;
    }

    public String buscar(){

        String query = "SELECT ?recurso "
               + " WHERE {"
               + "   ?recurso rdf:type "+getBuscarClase()+"."
               + "   ?recurso turistico:estaSituadoEn "+getBuscarLugar()+"."
               //+ "   OPTIONAL (?recurso dc:title ?titulo.)"
               //+ "   FILTER regex(?titulo, \""+getTextoBusqueda()+"\",\"i\")"
               + "}";
        System.out.println(query);
        Collection<RecursoTuristico> lista = getDatos().getRecursos(query);
        List<RecursoTuristico> listaFiltrada = new ArrayList<RecursoTuristico>();
        for(RecursoTuristico r:lista){
            if(testRecurso(r))
                listaFiltrada.add(r);
        }
        Collections.sort(listaFiltrada);
        BeanResolver.getLista().setListaRecursos(listaFiltrada);
        return "verLista";
    }

    private boolean testRecurso(RecursoTuristico r){
        if(!r.getNombre().toLowerCase().contains(getTextoBusqueda().toLowerCase())) return false;
        if(isBuscarImagen())
            if(r.getImagenes()==null || r.getImagenes().size()==0) return false;
        if(isBuscarVideo())
            if(r.getVideos()==null || r.getVideos().size()==0) return false;
        if(isBuscarWeb())
            if(r.getWebs()==null || r.getWebs().size()==0) return false;
        if(isBuscarWiki())
            if(r.getWiki()==null || r.getWiki().size()==0) return false;
        return true;
    }

    public String buscarClase(){
        if(getTextoBusqueda().isEmpty()) return "";
        BeanResolver.getLista().cargarListaPorClase("space:"+getTextoBusqueda());
        return "verLista";
    }

    public String buscarLugar(){
        if(getTextoBusqueda().isEmpty()) return "";
        BeanResolver.getLista().cargarListaPorLugar("mallorca:"+getTextoBusqueda());
        return "verLista";
    }

    public Collection<SelectItem> getLugaresSI(){
        List<SelectItem> lista = new ArrayList<SelectItem>();
        lista.add(new SelectItem("mallorca:Mallorca", "Todos"));
        lista.add(new SelectItem("mallorca:Palma", "Palma"));
        lista.add(new SelectItem("mallorca:Escorca", "Escorca"));
        lista.add(new SelectItem("mallorca:Marratxi", "Marratxí"));
        lista.add(new SelectItem("mallorca:Arta", "Artà"));
        lista.add(new SelectItem("mallorca:Felanitx", "Felanitx"));
        lista.add(new SelectItem("mallorca:Soller", "Soller"));
        lista.add(new SelectItem("mallorca:Manacor", "Manacor"));
        lista.add(new SelectItem("mallorca:Esporles", "Esporles"));
        lista.add(new SelectItem("mallorca:SantLlorenç", "Sant Llorenç des Cardessar"));
        lista.add(new SelectItem("mallorca:SonServera", "Son Servera"));
        lista.add(new SelectItem("mallorca:Valldemossa", "Vallemossa"));
        return lista;
    }

    public String getLugarString(){
        if(getBuscarLugar() == null) return "";
        for(SelectItem si:getLugaresSI()){
            if(si.getValue().equals(getBuscarLugar())) return si.getLabel();
        }
        return "";
    }

    public Collection<SelectItem> getTiposSI(){
        List<SelectItem> lista = new ArrayList<SelectItem>();
        lista.add(new SelectItem("turistico:PuntoDeInteres", "Todos"));
        lista.add(new SelectItem("space:Accommodation", "Alojamiento"));
        lista.add(new SelectItem("space:Shopping_facility", "Comercios y compras"));
        lista.add(new SelectItem("space:Market", " - Mercado"));
        lista.add(new SelectItem("space:Shopping_center", " - Centro comercial"));
        lista.add(new SelectItem("space:Eating_and_drinking", "Comida y bebida"));
        lista.add(new SelectItem("space:Bar", " - Bar"));
        lista.add(new SelectItem("space:Restaurant", " - Restaurante"));
        lista.add(new SelectItem("space:Tourist_structure", "Cultura e historia"));
        lista.add(new SelectItem("space:Monument", " - Monumento"));
        lista.add(new SelectItem("space:Museum", " - Museo"));
        lista.add(new SelectItem("space:Educational_structure", "Educación"));
        lista.add(new SelectItem("space:University", " - Universidad"));
        lista.add(new SelectItem("space:College", " - Instituto"));
        lista.add(new SelectItem("space:School", " - Escuela"));
        lista.add(new SelectItem("space:Kindergarten", " - Guardería"));
        lista.add(new SelectItem("space:Religious_structure", "Edificio religioso"));
        lista.add(new SelectItem("space:Cathedral", " - Catedral"));
        lista.add(new SelectItem("space:Entertainment", "Entretenimiento"));
        lista.add(new SelectItem("space:Aquarium", " - Acuario"));
        lista.add(new SelectItem("space:Cinema", " - Cine"));
        lista.add(new SelectItem("space:Stadium", " - Estadio"));
        lista.add(new SelectItem("space:Theater", " - Teatro"));
        lista.add(new SelectItem("space:Amusement_park", " - Parque de atracciones"));
        lista.add(new SelectItem("space:Government_structure", "Gobierno y servicios"));
        lista.add(new SelectItem("space:City_hall", " - Ayuntamiento"));
        lista.add(new SelectItem("space:Post_office", " - Correos"));
        lista.add(new SelectItem("space:Police_station", " - Policía"));
        lista.add(new SelectItem("space:Medical_structure", "Medicina"));
        lista.add(new SelectItem("space:Hospital", " - Hospital"));
        lista.add(new SelectItem("space:Geographical_feature", "Naturaleza"));
        lista.add(new SelectItem("space:Forest", " - Bosque"));
        lista.add(new SelectItem("space:Beach", " - Playa"));
        lista.add(new SelectItem("space:Bussiness_place", "Negocios"));
        lista.add(new SelectItem("space:Convention_center", " - Centro de convenciones"));
        lista.add(new SelectItem("space:Transportation_structure", "Transporte"));
        lista.add(new SelectItem("space:Airport", " - Aeropuerto"));
        lista.add(new SelectItem("space:Park", "Parque"));
        return lista;
    }

    public String getTipoString(){
        if(getBuscarClase() == null) return "";
        for(SelectItem si:getTiposSI()){
            if(si.getValue().equals(getBuscarClase())) return si.getLabel();
        }
        return "";
    }

    public String getMultimediasString(){
        String texto = "";
        List<String> textos = new ArrayList<String>();
        if(isBuscarImagen()) textos.add("Imagen");
        if(isBuscarVideo()) textos.add("Video");
        if(isBuscarWeb()) textos.add("Web");
        if(isBuscarWiki()) textos.add("Wiki");
        for(String t:textos){
            if(!texto.isEmpty())
                texto += ", ";
            texto += t;
        }
        return texto;
    }
}
