/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.aybkamen.tfc.recursos;

import com.aybkamen.tfc.persistencia.ConectorDatos;
import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.vocabulary.RDF;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 *
 * @author aybkamen
 */
public abstract class RecursoTFC{

    protected String tipo;
    protected Resource resource;
    protected String iri;
    protected ConectorDatos conector;

    public RecursoTFC(String iri, ConectorDatos conector) throws Exception {
        this.resource = conector.getModel().getResource(iri);
        if(resource.getProperty(RDF.type)!=null)
        this.tipo = resource.getProperty(RDF.type).getObject().asResource().getLocalName();
        this.iri = iri;
        this.conector = conector;
    }

    public String getIri() {
        return iri;
    }

    public void setIri(String iri) {
        this.iri = iri;
    }

    public Resource getResource() {
        return resource;
    }

    public void setResource(Resource resource) {
        this.resource = resource;
    }

    public String getTipo() {
        return tipo;
    }

    public void setTipo(String tipo) {
        this.tipo = tipo;
    }

    protected ConectorDatos getConector() {
        return conector;
    }

    protected void setConector(ConectorDatos conector) {
        this.conector = conector;
    }

    public String getValor(String literal){
        for(Statement st:getProperties()){
            if(st.getPredicate().getLocalName().equalsIgnoreCase(literal))
                return st.getObject().toString();
        }
        return "";
    }

    public Collection<Statement> getProperties(){
        List<Statement> lista = new ArrayList<Statement>();
        StmtIterator it = resource.listProperties();
        while(it.hasNext()){
            Statement st = it.nextStatement();
            lista.add(st);
        }
        return lista;
    }

    public String getLocalName(){
        return resource.getLocalName();
    }


}
