/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.aybkamen.tfc.recursos;

import com.aybkamen.tfc.persistencia.ConectorDatos;
import com.aybkamen.utils.Utils;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.vocabulary.RDF;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 *
 * @author aybkamen
 */
public class RecursoTuristico extends RecursoTFC implements Comparable<RecursoTuristico>{

    private String nombre;
    private Collection<RecursoDigital> recursosDigitales;
    private String latitud;
    private String longitud;

    public RecursoTuristico(String iri, ConectorDatos conector) throws Exception{
        super(iri, conector);
        this.nombre = getValor("title");
        this.latitud = getValor("latitude");
        this.longitud = getValor("longitude");
    }

    public Collection<RecursoDigital> getRecursosDigitales (){
        if(recursosDigitales==null){
            this.recursosDigitales = getConector().getDigitalesPDI(iri);
        }
        return recursosDigitales;
    }

    public String getNombre() {
        return nombre;
    }

    public String getLatitud() {
        return latitud;
    }

    public String getLongitud() {
        return longitud;
    }

    public Collection<RecursoDigital> getVideos(){
        return getRecursosDigitalesTipo(RecursoDigital.TIPO_VIDEO);
    }

    public Collection<RecursoDigital> getImagenes(){
        return getRecursosDigitalesTipo(RecursoDigital.TIPO_IMAGEN);
    }

    public Collection<RecursoDigital> getWebs(){
        return getRecursosDigitalesTipo(RecursoDigital.TIPO_WEB);
    }

    public Collection<RecursoDigital> getWiki(){
        return getRecursosDigitalesTipo(RecursoDigital.TIPO_WIKI);
    }


    public Collection<RecursoDigital> getRecursosDigitalesTipo(String tipoDigital){
        List<RecursoDigital> lista = new ArrayList<RecursoDigital>();
        for(RecursoDigital r:getRecursosDigitales()){
            if(r.getTipo().equals(tipoDigital))
                lista.add(r);
        }
        if(lista.isEmpty()) return null;
        return lista;
    }

    public Collection<String> getTipologias(){
        List<String> lista = new ArrayList<String>();
        for(Statement st: resource.listProperties(RDF.type).toSet()){
            String valor = Utils.getTexto(st.getObject().asResource().getLocalName());
            if(valor!=null)
                lista.add(valor);
        }
        return lista;
    }

    public int compareTo(RecursoTuristico t) {
        return this.getNombre().compareTo(t.getNombre());
    }


    

    
}
